
// gelato - A openobjectlib plugin to NVIDIA's Gelato(tm).

// Copyright (C) 2005 Visual Media FX Ltd.
// Released under the LGPL.
// For more information, see http://www.openobjectlib.org.

#ifndef GELATO_DRAW_ACTION_INC_
#define GELATO_DRAW_ACTION_INC_

#include <openobjectlib/plugins/Gelato/gelato/gelatoapi.hpp>
#include <openobjectlib/plugins/Gelato/gelato/config.hpp>


namespace olib { namespace openobjectlib { namespace plugins { namespace gelato {

////////////////////////////////////////////////////////////
// renders a openobjectlib scene with NVIDIA's Gelato (tm)
class GELATO_DECLSPEC gelato_draw_action
{
public:
	typedef bool return_type;

public:
	explicit gelato_draw_action( );
	virtual ~gelato_draw_action( );

	virtual return_type start( );
	virtual return_type finish( );
	
public:
#ifdef HAVE_GELATO_RUNTIME
	GelatoAPI* get_renderer( ) const
	{ return renderer_; }
	void set_renderer( GelatoAPI* renderer )
	{ renderer_ = renderer; }
#endif

private:
#ifdef HAVE_GELATO_RUNTIME
	GelatoAPI* renderer_;
#endif
};

} } } }

#endif
